<?php
/*
Plugin Name: WP-SimpleViewer
Plugin URI: http://wp-simpleviewer.fuggi82.de
Description: Include the <a href="http://www.airtightinteractive.com/simpleviewer" target="_blank">SimpleViewer</a> Flash gallery (v1.8) into WordPress.
Version: 1.0
Author: fuggi
Author URI: http://wp-simpleviewer.fuggi82.de
*/

/*  Copyright 2007  Markus F. ( wp-simpleviewer@fuggi82.de )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307USA
*/

/*  Permission handling or which user is allowed to do what?

	Capability			Role						...is allowed to?
	manage_options		admin						Manage the default parameters (the options page)
	edit_posts			contributor and all above	create new XML files
	edit_others_posts	editor & admin				create new and recreate existing XML files

*/

add_action('admin_menu',  'wp_simpleviewer_add_options_page');
add_action('admin_menu',  'wp_simpleviewer_add_management_page');
add_action('wp_head',     'wp_simpleviewer_wp_head');
add_filter('the_content', 'wp_simpleviewer');

function wp_simpleviewer_add_options_page() {
	if (function_exists('add_options_page')) {
    	add_options_page('WP-SimpleViewer', 'WP-SimpleViewer', 'manage_options', basename(__FILE__), 'wp_simpleviewer_options_page');
	}
}

function wp_simpleviewer_add_management_page() {
	if (function_exists('add_management_page')) {
    	add_management_page('WP-SimpleViewer Galleries', 'WP-SimpleViewer Galleries', 'edit_posts', basename(__FILE__), 'wp_simpleviewer_manage_page');
	}
}

function wp_simpleviewer_wp_head() {
	//get wp-simpleviewer parameters:
	$wp_simpleviewer_plugin_basedir = get_option('wp_simpleviewer_plugin_basedir');
	//get WordPress URL
	$siteurl = get_option('siteurl'); 
	echo '<script type="text/javascript" src="'.$siteurl.'/wp-content/plugins/'.$wp_simpleviewer_plugin_basedir.'swfobject.js"></script>';
}

function wp_simpleviewer($content)
{
	$count = preg_match_all('/svgallery\=([-_a-zA-Z01-9]*)/i', $content, $matches);
	
	if ($count > 0) {	//There should be a gallery on this page
		//get wp-simpleviewer parameters:
		$wp_simpleviewer_plugin_basedir = get_option("wp_simpleviewer_plugin_basedir");
		$wp_simpleviewer_images_basedir = get_option("wp_simpleviewer_images_basedir");
		//get WordPress URLs
		$siteurl = get_option("siteurl");
		$home = get_option("home");
		//is WordPRess installed in a subdirectory?
		if ( strcmp( $siteurl, $home) ) {
			$home = str_replace($home.'/', '', $siteurl);
			if ( strlen($home) > 0) {
				$home = $home.'/';
			}
		} else {
			$home = '';
		}
		
		for ($i = 0; $i < $count; $i++) {
			$galleryname=attribute_escape($matches[1][$i]);
			$wp_simpleviewer_xmlfile =  $home.$wp_simpleviewer_images_basedir.$galleryname.'/gallery.xml';
			
			//check if xml file exists and get variables
			if ( !is_readable($wp_simpleviewer_xmlfile) ) {
				$wp_simpleviewer_code = 'I cannot find the gallery\'s xml file: '.$wp_simpleviewer_xmlfile.' <br />Please check that the gallery\'s files have been created on the admin pages!<br />';
			}else{
				if ( !$wp_simpleviewer_xmlfile_handle = fopen($wp_simpleviewer_xmlfile,"rb") ) {
					$wp_simpleviewer_code = 'I cannot open the xml file to read: '.$wp_simpleviewer_xmlfile.' <br />Please check that the file permissions!<br />';
				}else{
					$wp_simpleviewer_xml_file_data = fread($wp_simpleviewer_xmlfile_handle, filesize($wp_simpleviewer_xmlfile) );
					if ( preg_match('/wpSimpleviewerWidth="([01-9\%]*)" wpSimpleviewerHeight="([01-9\%]*)" wpSimpleviewerBackgroundColor="([01-9a-fA-F]*)"/is', $wp_simpleviewer_xml_file_data, $wp_simpleviewer_gallerydata) ){
						$wp_simpleviewer_width = $wp_simpleviewer_gallerydata[1];
						$wp_simpleviewer_height = $wp_simpleviewer_gallerydata[2];
						$wp_simpleviewer_bgcolor = $wp_simpleviewer_gallerydata[3];
					}else{
						$wp_simpleviewer_width = get_option("wp_simpleviewer_width");
						$wp_simpleviewer_height = get_option("wp_simpleviewer_height");
						$wp_simpleviewer_bgcolor = get_option("wp_simpleviewer_bgcolor");
					}
					fclose($wp_simpleviewer_xmlfile_handle);
					
					//this variable will be used for the name of the <div>
					$flashcontent = 'fc_id_'.mt_rand(0,1000);
					
					$wp_simpleviewer_code = '
					</p>
					<div id="'.$flashcontent.'">
					SimpleViewer requires Macromedia Flash. <a href="http://www.macromedia.com/go/getflashplayer/">Get Macromedia Flash.</a>
					<br />
					This is a <a href="http://wp-simpleviewer.fuggi82.de">WPSimpleViewerGallery</a>
					</div>
					<script type="text/javascript">
						var fo = new SWFObject("'.$siteurl.'/wp-content/plugins/'.$wp_simpleviewer_plugin_basedir.'viewer.swf", "viewer", "'.$wp_simpleviewer_width.'", "'.$wp_simpleviewer_height.'", "7", "#'.$wp_simpleviewer_bgcolor.'");	
						fo.addVariable("preloaderColor", "0xffffff");
						fo.addVariable("xmlDataPath", "'.$siteurl.'/'.$wp_simpleviewer_images_basedir.$galleryname.'/gallery.xml");	
						fo.write("'.$flashcontent.'");	
					</script>
					<p>';
					
				}	//end if fopen
			}	//end if is_readable
			$content = preg_replace( '/svgallery\='.$matches[1][$i].'/i', $wp_simpleviewer_code, $content, 1);	
		}	//end for i
	}	//end if count > 0
	return $content;
}

function wp_simpleviewer_manage_page() {
	$wp_simpleviewer_nonce="wp-simpleviewer-option_";
	
	if (!get_option('wp_simpleviewer_version_installed')) {	//The plugin has not been installed yet, ask admin to install it
		_e('The WP-SimpleViewer has not been configured yet. Ask your administator to configure it on the plugin\'s option page.</ br>');
	} else {
		if ( isset($_POST['option']) ) {
			$wp_simpleviewer_option = attribute_escape($_POST['option']);

			if ( isset($_POST['wp_simpleviewer_width']) ) {
				$wp_simpleviewer_width = attribute_escape($_POST['wp_simpleviewer_width']);
			}
			if ( isset($_POST['wp_simpleviewer_height']) ) {
				$wp_simpleviewer_height = attribute_escape($_POST['wp_simpleviewer_height']);
			} 
			if ( isset($_POST['wp_simpleviewer_textcolor']) ) {
				$wp_simpleviewer_textcolor = attribute_escape($_POST['wp_simpleviewer_textcolor']);
			}
			if ( isset($_POST['wp_simpleviewer_framecolor']) ) {
				$wp_simpleviewer_framecolor = attribute_escape($_POST['wp_simpleviewer_framecolor']);
			}
			if ( isset($_POST['wp_simpleviewer_bgcolor']) ) {
				$wp_simpleviewer_bgcolor = attribute_escape($_POST['wp_simpleviewer_bgcolor']);
			}
			if ( isset($_POST['wp_simpleviewer_framewidth']) ) {
				$wp_simpleviewer_framewidth = attribute_escape($_POST['wp_simpleviewer_framewidth']);
			}
			if ( isset($_POST['wp_simpleviewer_stagepadding']) ) {
				$wp_simpleviewer_stagepadding = attribute_escape($_POST['wp_simpleviewer_stagepadding']);
			}
			if ( isset($_POST['wp_simpleviewer_thumbnailcolumns']) ) {
				$wp_simpleviewer_thumbnailcolumns = attribute_escape($_POST['wp_simpleviewer_thumbnailcolumns']);
			}
			if ( isset($_POST['wp_simpleviewer_thumbnailrows']) ) {
				$wp_simpleviewer_thumbnailrows = attribute_escape($_POST['wp_simpleviewer_thumbnailrows']);
			}
			if ( isset($_POST['wp_simpleviewer_navposition']) ) {
				$wp_simpleviewer_navposition = attribute_escape($_POST['wp_simpleviewer_navposition']);
			}
			if ( isset($_POST['wp_simpleviewer_right_click_menu']) ) {
				$wp_simpleviewer_right_click_menu = attribute_escape($_POST['wp_simpleviewer_right_click_menu']);
			}
			if ( isset($_POST['wp_simpleviewer_standard_title']) ) {
				$wp_simpleviewer_standard_title = str_replace("\\\"", ' ', $_POST['wp_simpleviewer_standard_title']);
				$wp_simpleviewer_standard_title = str_replace("\'", " ", $wp_simpleviewer_standard_title);
				$wp_simpleviewer_standard_title = attribute_escape( $wp_simpleviewer_standard_title );
			}
			if ( isset($_POST['wp_simpleviewer_max_image_size']) ) {
				$wp_simpleviewer_max_image_size = attribute_escape($_POST['wp_simpleviewer_max_image_size']);
			}
			if ( isset($_POST['wp_simpleviewer_resizequality']) ) {
				$wp_simpleviewer_resizequality = attribute_escape($_POST['wp_simpleviewer_resizequality']);
			} else {
				$wp_simpleviewer_resizequality = get_option("wp_simpleviewer_resizequality");
			}
			if ( isset($_POST['wp_simpleviewer_show_download_link']) ) {
				$wp_simpleviewer_show_download_link = attribute_escape($_POST['wp_simpleviewer_show_download_link']);
			} else {
				$wp_simpleviewer_show_download_link = get_option("wp_simpleviewer_show_download_link");
			}
			if ( isset($_POST['wp_simpleviewer_default_download_link_text']) ) {
				$wp_simpleviewer_default_download_link_text = str_replace("\\\"", ' ', $_POST['wp_simpleviewer_default_download_link_text']);
				$wp_simpleviewer_default_download_link_text = str_replace("\'", " ", $wp_simpleviewer_default_download_link_text);
				$wp_simpleviewer_default_download_link_text = attribute_escape( $wp_simpleviewer_default_download_link_text );
			} else {
				$wp_simpleviewer_default_download_link_text = get_option("wp_simpleviewer_default_download_link_text");
			}
			if ( isset($_POST['wp_simpleviewer_xmlfile']) ) {
				$wp_simpleviewer_xmlfile = attribute_escape( $_POST['wp_simpleviewer_xmlfile'] );
			}
			if ( isset($_POST['wp_simpleviewer_folder_regulars']) ) {
				$wp_simpleviewer_foldername_regular_composed = attribute_escape( $_POST['wp_simpleviewer_folder_regulars'] );
			}
			if ( isset($_POST['wp_simpleviewer_folder_thumbnails']) ) {
				$wp_simpleviewer_foldername_thumbnails_composed = attribute_escape( $_POST['wp_simpleviewer_folder_thumbnails'] );
			}
			if ( isset($_POST['wp_simpleviewer_number_of_images']) ) {
				$wp_simpleviewer_number_of_images = attribute_escape( $_POST['wp_simpleviewer_number_of_images'] );
			}
		} elseif ( isset($_GET['option']) ) {
			$wp_simpleviewer_option = attribute_escape($_GET['option']);
		} else {	//first call of the page, get default values
			$wp_simpleviewer_width = get_option("wp_simpleviewer_width");
			$wp_simpleviewer_height = get_option("wp_simpleviewer_height");
			$wp_simpleviewer_textcolor = get_option("wp_simpleviewer_textcolor");
			$wp_simpleviewer_framecolor = get_option("wp_simpleviewer_framecolor");
			$wp_simpleviewer_bgcolor = get_option("wp_simpleviewer_bgcolor");
			$wp_simpleviewer_framewidth = get_option("wp_simpleviewer_framewidth");
			$wp_simpleviewer_stagepadding = get_option("wp_simpleviewer_stagepadding");
			$wp_simpleviewer_thumbnailcolumns = get_option("wp_simpleviewer_thumbnailcolumns");
			$wp_simpleviewer_thumbnailrows = get_option("wp_simpleviewer_thumbnailrows");
			$wp_simpleviewer_navposition = get_option("wp_simpleviewer_navposition");
			$wp_simpleviewer_right_click_menu = get_option("wp_simpleviewer_right_click_menu");
			$wp_simpleviewer_standard_title = get_option("wp_simpleviewer_standard_title");
			$wp_simpleviewer_max_image_size = get_option("wp_simpleviewer_max_image_size");
			$wp_simpleviewer_resizequality = get_option("wp_simpleviewer_resizequality");
			$wp_simpleviewer_show_download_link = get_option("wp_simpleviewer_show_download_link");
			$wp_simpleviewer_default_download_link_text = get_option("wp_simpleviewer_default_download_link_text");
		}
		$wp_simpleviewer_plugin_basedir = get_option("wp_simpleviewer_plugin_basedir");
		$wp_simpleviewer_images_basedir = get_option("wp_simpleviewer_images_basedir");
		$wp_simpleviewer_folder_regular = get_option("wp_simpleviewer_folder_regular");
		$wp_simpleviewer_folder_thumbnails = get_option("wp_simpleviewer_folder_thumbnails");
		
		//get WordPress URL
		$siteurl = get_option("siteurl");
		
		// Check if a directory has been selected to create a new gallery
		if ( $wp_simpleviewer_option == 'create' && !isset($_POST['wp_simpleviewer_foldername']) ) {
			echo '<div id="message" class="updated fade"><p><strong>You have not selected a folder that you want to use as a gallery!</strong></p></div>';
		} elseif ( $wp_simpleviewer_option == 'create' ) {
			if ( function_exists('check_admin_referer') ) {
				check_admin_referer($wp_simpleviewer_nonce.'create');
			}
			
			$wp_simpleviewer_foldername = attribute_escape($_POST['wp_simpleviewer_foldername']);
			$wp_simpleviewer_foldername_composed = '../'.$wp_simpleviewer_images_basedir.$wp_simpleviewer_foldername.'/';
			$wp_simpleviewer_xmlfile = $wp_simpleviewer_foldername_composed.'gallery.xml';
			$wp_simpleviewer_foldername_regular_composed = $wp_simpleviewer_foldername_composed.$wp_simpleviewer_folder_regular;
			$wp_simpleviewer_foldername_thumbnails_composed = $wp_simpleviewer_foldername_composed.$wp_simpleviewer_folder_thumbnails;
			//This is the string for the XML output:
			$wp_simpleviewer_xml  = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
			$wp_simpleviewer_xml .= '<simpleviewerGallery maxImageWidth="'.$wp_simpleviewer_max_image_size.'" maxImageHeight="'.$wp_simpleviewer_max_image_size.'" textColor="0x'.$wp_simpleviewer_textcolor.'" frameColor="0x'.$wp_simpleviewer_framecolor.'" frameWidth="'.$wp_simpleviewer_framewidth.'" stagePadding="'.$wp_simpleviewer_stagepadding.'" thumbnailColumns="'.$wp_simpleviewer_thumbnailcolumns.'" thumbnailRows="'.$wp_simpleviewer_thumbnailrows.'" navPosition="'.$wp_simpleviewer_navposition.'" enableRightClickOpen="'.$wp_simpleviewer_right_click_menu.'" title="'.$wp_simpleviewer_standard_title.'" imagePath="'.$siteurl.'/'.$wp_simpleviewer_images_basedir.$wp_simpleviewer_foldername.'/'.$wp_simpleviewer_folder_regular.'/" thumbPath="'.$siteurl.'/'.$wp_simpleviewer_images_basedir.$wp_simpleviewer_foldername.'/'.$wp_simpleviewer_folder_thumbnails.'/" wpSimpleviewerWidth="'.$wp_simpleviewer_width.'" wpSimpleviewerHeight="'.$wp_simpleviewer_height.'" wpSimpleviewerBackgroundColor="'.$wp_simpleviewer_bgcolor.'">'."\n";
			
			cleanup_old_files($wp_simpleviewer_xmlfile, $wp_simpleviewer_foldername_regular_composed, $wp_simpleviewer_foldername_thumbnails_composed);
			
			if ( mkdir ($wp_simpleviewer_foldername_regular_composed, 0777) && mkdir ($wp_simpleviewer_foldername_thumbnails_composed, 0777) ) {	//create new directories
				chmod ($wp_simpleviewer_foldername_regular_composed, 0777);
				chmod ($wp_simpleviewer_foldername_thumbnails_composed, 0777);
				
				//start update box for WordPress
				echo '<div id="message" class="updated fade"><p>';
				//show GD imaging library version
				$gdInfo    = gd_info(); 
				echo 'GD library version 2 or later is required. You are running version: '.$gdInfo["GD Version"].'<br /><br />';
				
				echo 'Now the images and XML file for the selected folder will be created:<br /><br />'; 
				
				//Open foldername and add all image filenames to an array sorted by name
				$directory_handle = opendir($wp_simpleviewer_foldername_composed);
				while($file = readdir($directory_handle)) {	
					if ($file[0] != "." && $file[0] != ".." && !is_dir($wp_simpleviewer_foldername_composed.$file) ) {
						if ( getExtension($file) == "jpg" || getExtension($file) == "png" ){
							$files_array[$file] = $file;
						} else {
							echo 'The file called '.$file.' will not be included into the gallery - it is no jpg or png file <br />';
						}
					}		
				}	//end while readdir(...)
				
				if ( !isset($files_array) ) {
					echo 'The directory you selected does not contain any jpg or png files. Please upload them first (and ignore the rest of the page)!<br /><br />';
				} else {
					sort($files_array);					
					/*If the plugin should hang up while it is creating the thumbs (last line on the admin is: "Now I am working on file xxx.jpg:") you
					can try to uncomment the following line (remove // ) to define a new memory limit (40MB in this case). More info on the plugins FAQ.*/
					//ini_set("memory_limit","40M");
					foreach($files_array as $filename_without_directory) {
						//the script should not work on one photo longer than 30s 
						set_time_limit(30);
						
						echo 'Now I am working on file '.$filename_without_directory.': <br />';
						$filename_original  = $wp_simpleviewer_foldername_composed.$filename_without_directory;
						$filename_regular   = $wp_simpleviewer_foldername_regular_composed."/".$filename_without_directory;
						$filename_thumbnail = $wp_simpleviewer_foldername_thumbnails_composed."/".$filename_without_directory;
						
						//create regular image and thumbnail
						if (!file_exists($filename_regular) && !file_exists($filename_thumbnail) ){					
							if (create_resized_image($filename_original, $filename_regular, false, $wp_simpleviewer_max_image_size, $wp_simpleviewer_resizequality)){
								chmod($filename_regular,0777);
								echo '   I have created the regular image ';
								if (create_resized_image($filename_original, $filename_thumbnail, true, 65, $wp_simpleviewer_resizequality)){	//thumbnails are suared with 65px width/height
									chmod($filename_thumbnail,0777);
									echo 'and the thumbnail ';
									//and add the image to the XML file
									$wp_simpleviewer_xml .= '   <image>'."\n";
									$wp_simpleviewer_xml .= '      <filename>'.$filename_without_directory.'</filename>'."\n";
											
									if ($wp_simpleviewer_show_download_link == "true"){		
										$wp_simpleviewer_xml .= '      <caption><![CDATA[<A href="'.$siteurl.'/'.$wp_simpleviewer_images_basedir.$wp_simpleviewer_foldername.'/'.$filename_without_directory.'" target="_blank"><U>'.$wp_simpleviewer_default_download_link_text.'</U></A>]]></caption>'."\n";
									} elseif ($wp_simpleviewer_show_download_link == "captions only") {
										$wp_simpleviewer_xml .= '      <caption><![CDATA['.$wp_simpleviewer_default_download_link_text.']]></caption>'."\n";
									} else {
										$wp_simpleviewer_xml .= '      <caption><![CDATA[]]></caption>'."\n";
									}
									$wp_simpleviewer_xml .= '   </image>'."\n";
									
									echo 'and now it has been added to the XML file!<br />';
								}			
							}									
						}
						
					}	//end for each
				}	//end if isset files_array
				closedir($directory_handle);
				$wp_simpleviewer_xml .= '</simpleviewerGallery>';
				 
				if ( !$wp_simpleviewer_xmlfile_handle = @fopen($wp_simpleviewer_xmlfile,"w") ) { 
					echo 'I cannot open XML file: '.$file.' <br />Please check that write permissions of the folder are correct!<br />';
				} elseif ( !fwrite($wp_simpleviewer_xmlfile_handle, $wp_simpleviewer_xml) ) { 
					echo 'I have opened the XML file, but I was not able to write into it: '.$file.'<br />Please check that write permissions of the folder are correct!<br />';   
				} else {
					echo '<br />Yeah, we are done!'; 
				}
				fclose($wp_simpleviewer_xmlfile_handle);
				chmod($wp_simpleviewer_xmlfile,0777); 		
				
				echo '</p></div>'; //end update box for WordPress (fading div box)
			} else {
				_e('<div id="message" class="updated fade"><p>Sorry, but I could not create the subfolders for the thumbnails. </p></div>');
			}
				
		}	//end if option == create
			
		if ( $wp_simpleviewer_option == 'editxml' || ( $wp_simpleviewer_option == 'create' && isset($_POST['wp_simpleviewer_foldername']) ) ) {	//show xml file's content to edit it
			if ($wp_simpleviewer_option == 'editxml') {
				if ( function_exists('check_admin_referer') ) {
					check_admin_referer($wp_simpleviewer_nonce.'editxml');
					$wp_simpleviewer_foldername = attribute_escape($_GET['wp_simpleviewer_foldername']);
				}
			} else {
				if ( function_exists('check_admin_referer') ) {
					check_admin_referer($wp_simpleviewer_nonce.'create');
					$wp_simpleviewer_foldername = attribute_escape($_POST['wp_simpleviewer_foldername']);
				}
			}
			
			?>
			<div class="wrap">
			<p class="submit">
				<form name="form1" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo( attribute_escape($_GET['page']) ); ?>">
				<input type="submit" name="Submit" value="<?php _e('Back to the gallery list without editing the captions') ?> &raquo;" />
				</form>
			</p>
			<h2><?php _e('Edit captions for gallery '.$wp_simpleviewer_foldername) ?></h2> 
			<?php
			$wp_simpleviewer_xmlfile = '../'.$wp_simpleviewer_images_basedir.$wp_simpleviewer_foldername.'/'.'gallery.xml';
			//check if xml file exists and get variables
			if ( !file_exists($wp_simpleviewer_xmlfile) ) {
				echo 'I cannot find the gallery\'s xml file: '.$file.' <br />Please check that the gallery\'s files have been created on the admin pages!<br />';
			} else {
				if ( !$wp_simpleviewer_xmlfile_handle = @fopen($wp_simpleviewer_xmlfile,"rb") ) {
					echo 'I cannot open the xml file to read: '.$file.' <br />Please check that the file permissions!<br />';
				} else {
					$wp_simpleviewer_xml_file_data = fread($wp_simpleviewer_xmlfile_handle, filesize($wp_simpleviewer_xmlfile) );
					fclose($wp_simpleviewer_xmlfile_handle);
					
					$count = preg_match_all('/<filename>([_-a-zA-Z01-9\.]*)<\/filename>/i', $wp_simpleviewer_xml_file_data, $wp_simpleviewer_filenames);

					if ($count == 0) {	//no images found in XML file
						echo 'No images found in the xml file.<br />Please check that there are image files in the directory!<br />';
					} else {//there are images in the file, so now we will get the captions for them
						preg_match('/maxImageWidth\="([01-9]*)" maxImageHeight\="([01-9]*)" textColor\="0x([01-9A-Fa-f]*)" frameColor\="0x([01-9A-Fa-f]*)" frameWidth\="([01-9]*)" stagePadding\="([01-9]*)" thumbnailColumns\="([01-9]*)" thumbnailRows\="([01-9]*)" navPosition\="([a-z]*)" enableRightClickOpen\="([a-z]*)" title\="(.*)" imagePath\="(.*)" thumbPath\="(.*)" wpSimpleviewerWidth\="([01-9\%]*)" wpSimpleviewerHeight\="([01-9\%]*)" wpSimpleviewerBackgroundColor\="([01-9a-fA-F]*)"/i', $wp_simpleviewer_xml_file_data, $wp_simpleviewer_options);
						
						if ( !preg_match_all('/<caption><\!\[CDATA\[<A.*<U>(.*)<\/U><\/A>\]\]><\/caption>/i', $wp_simpleviewer_xml_file_data, $wp_simpleviewer_captions) ) {
							preg_match_all('/<caption><\!\[CDATA\[(.*)\]\]><\/caption>/i', $wp_simpleviewer_xml_file_data, $wp_simpleviewer_captions);
						} 
						?>
						<form name="form2" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo( attribute_escape($_GET['page']) ); ?>">
						<?php 
						if ( function_exists('wp_nonce_field') ) {
							wp_nonce_field($wp_simpleviewer_nonce.'writenewxml');
						}
						?>
						<table class="widefat"> 
							<thead>
							<tr>
								<th scope="col" style="text-align: center"><?php //_e('Image') ?></th>
								<th scope="col"><?php _e('Name') ?></th>
								<th scope="col"><?php _e('Caption') ?></th>
							</tr>
							</thead>
							
							<tbody id="the-list">
								<?php
								for ($i = 0; $i < $count; $i++) {
									if ( $i%2 ) {
										echo '<tr id="directory-'.$i.'" class="alternate" >';
									} else {
										echo '<tr id="directory-'.$i.'" >';
									}
									
									echo '<td><img src="'.$wp_simpleviewer_options[13].$wp_simpleviewer_filenames[1][$i].'" alt="'.$wp_simpleviewer_filenames[1][$i].'" /></td>'."\n";
									echo '<td> <input name="wp_simpleviewer_filename_'.$i.'" type="hidden" id="wp_simpleviewer_filename_'.$i.'" value="'.$wp_simpleviewer_filenames[1][$i].'" />'.$wp_simpleviewer_filenames[1][$i].'</td>'."\n";

									echo '<td><input name="wp_simpleviewer_completecaption_'.$i.'" type="hidden" id="wp_simpleviewer_completecaption_'.$i.'" value=\''.$wp_simpleviewer_captions[0][$i].'\' /> '."\n";
									echo '    <input name="wp_simpleviewer_oldcaption_'.$i.'" type="hidden" id="wp_simpleviewer_oldcaption_'.$i.'" value="'.$wp_simpleviewer_captions[1][$i].'" />'."\n";
									echo '    <input name="wp_simpleviewer_newcaption_'.$i.'" type="text" id="wp_simpleviewer_newcaption_'.$i.'" value="'.$wp_simpleviewer_captions[1][$i].'" size="50" /> </td>'."\n";
									echo '</tr>'."\n";
								}	//end for i
								?>
							</tbody>
						</table>
						<p class="submit">
							<input type="submit" name="Submit" value="<?php _e('Edit captions and options for this gallery') ?> &raquo;" />
						</p>
						<fieldset class="options">
							<legend><?php _e('Size and colors'); ?></legend>
							<table width="100%" cellspacing="2" cellpadding="5" class="optiontable editform"> 
								<tr valign="top"> 
									<th width="33%" scope="row"><?php _e('Width:'); ?></th> 
									<td><input name="wp_simpleviewer_width" type="text" id="wp_simpleviewer_width" value="<?php echo $wp_simpleviewer_options[14]; ?>" size="10" /><br />
										<?php _e('Default width of the SimpleViewer gallery as it should be shown on the page, e.g. 500 for 500 pixels or 90%.') ?></td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Height:'); ?></th> 
									<td><input name="wp_simpleviewer_height" type="text" id="wp_simpleviewer_height" value="<?php echo $wp_simpleviewer_options[15]; ?>" size="10" /><br />
										<?php _e('Default height of the SimpleViewer gallery as it should be shown on the page, e.g. 500 for 500 pixels or 90%.') ?></td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Textcolor:'); ?></th> 
									<td>#<input name="wp_simpleviewer_textcolor" type="text" id="wp_simpleviewer_textcolor" value="<?php echo $wp_simpleviewer_options[3]; ?>" size="10" /></td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Framecolor:'); ?></th> 
									<td>#<input name="wp_simpleviewer_framecolor" type="text" id="wp_simpleviewer_framecolor" value="<?php echo $wp_simpleviewer_options[4]; ?>" size="10" /></td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Backgroundcolor:'); ?></th> 
									<td>#<input name="wp_simpleviewer_bgcolor" type="text" id="wp_simpleviewer_bgcolor" value="<?php echo $wp_simpleviewer_options[16]; ?>" size="10" /></td>
								</tr> 
							</table> 
						</fieldset>
						
						<fieldset class="options">
							<legend><?php _e('Gallery creation and appearance'); ?></legend>
							<table width="100%" cellspacing="2" cellpadding="5" class="optiontable editform"> 
								<tr valign="top"> 
									<th width="33%" scope="row"><?php _e('Framewidth:'); ?></th> 
									<td><input name="wp_simpleviewer_framewidth" type="text" id="wp_simpleviewer_framewidth" value="<?php echo $wp_simpleviewer_options[5]; ?>" size="10" /> pixels</td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Stagepadding:'); ?></th> 
									<td><input name="wp_simpleviewer_stagepadding" type="text" id="wp_simpleviewer_stagepadding" value="<?php echo $wp_simpleviewer_options[6]; ?>" size="10" /> pixels</td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Number of thumbnails in one row:'); ?></th> 
									<td><input name="wp_simpleviewer_thumbnailcolumns" type="text" id="wp_simpleviewer_thumbnailcolumns" value="<?php echo $wp_simpleviewer_options[7]; ?>" size="10" /></td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Number of thumbnail rows:'); ?></th> 
									<td><input name="wp_simpleviewer_thumbnailrows" type="text" id="wp_simpleviewer_thumbnailrows" value="<?php echo $wp_simpleviewer_options[8]; ?>" size="10" /></td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Position of navigation:'); ?></th> 
									<td><select name="wp_simpleviewer_navposition" id="wp_simpleviewer_navposition" size="1">
									<option <?php if ($wp_simpleviewer_options[9]=="top") echo 'selected="selected"'; ?>>top</option>
									<option <?php if ($wp_simpleviewer_options[9]=="bottom") echo 'selected="selected"'; ?>>bottom</option>
									<option <?php if ($wp_simpleviewer_options[9]=="left") echo 'selected="selected"'; ?>>left</option>
									<option <?php if ($wp_simpleviewer_options[9]=="right") echo 'selected="selected"'; ?>>right</option>
									</select> </td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Enable right click open:'); ?></th> 
									<td><select name="wp_simpleviewer_right_click_menu" id="wp_simpleviewer_right_click_menu" size="1">
									<option <?php if ($wp_simpleviewer_options[10] =="true") echo 'selected="selected"'; ?>>true</option>
									<option <?php if ($wp_simpleviewer_options[10] =="false") echo 'selected="selected"'; ?>>false</option>
									</select> </td>
								</tr> 
								<tr valign="top">
									<th width="33%" scope="row"><?php _e('Gallery title:'); ?></th> 
									<td><?php _e('If the gallery should have a title write it down here, otherwise just leave it empty.') ?><br />
									<input name="wp_simpleviewer_standard_title" type="text" id="wp_simpleviewer_standard_title" value="<?php echo $wp_simpleviewer_options[11]; ?>" size="40" /></td>
								</tr> 
							</table> 
						</fieldset>
						
						<p class="submit">
							<input type="hidden" name="option" value="writenewxml" />
							<input name="wp_simpleviewer_max_image_size" type="hidden" id="wp_simpleviewer_max_image_size" value="<?php echo $wp_simpleviewer_options[1]; ?>" />
							<input name="wp_simpleviewer_folder_thumbnails" type="hidden" id="wp_simpleviewer_folder_thumbnails" value="<?php echo $wp_simpleviewer_options[13]; ?>" />
							<input name="wp_simpleviewer_folder_regulars" type="hidden" id="wp_simpleviewer_folder_regulars" value="<?php echo $wp_simpleviewer_options[12]; ?>" />
							<input name="wp_simpleviewer_xmlfile" type="hidden" id="wp_simpleviewer_xmlfile" value="<?php echo $wp_simpleviewer_xmlfile; ?>" />
							<input name="wp_simpleviewer_number_of_images" type="hidden" id="wp_simpleviewer_number_of_images" value="<?php echo $count; ?>" />
							
							<input type="submit" name="Submit" value="<?php _e('Edit captions and options for this gallery') ?> &raquo;" />
						</p>
						</form>
						
						<?php					
					}	//end if count > 0
				}	//end if fopen
			}	//end if file exists
		} elseif ( $wp_simpleviewer_option == 'writenewxml' ) {	//write new xml file
			if ( function_exists('check_admin_referer') ) {
				check_admin_referer($wp_simpleviewer_nonce.'writenewxml');
			}
			
			//This is the string for the XML output:
			$wp_simpleviewer_xml  = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
			$wp_simpleviewer_xml .= '<simpleviewerGallery maxImageWidth="'.$wp_simpleviewer_max_image_size.'" maxImageHeight="'.$wp_simpleviewer_max_image_size.'" textColor="0x'.$wp_simpleviewer_textcolor.'" frameColor="0x'.$wp_simpleviewer_framecolor.'" frameWidth="'.$wp_simpleviewer_framewidth.'" stagePadding="'.$wp_simpleviewer_stagepadding.'" thumbnailColumns="'.$wp_simpleviewer_thumbnailcolumns.'" thumbnailRows="'.$wp_simpleviewer_thumbnailrows.'" navPosition="'.$wp_simpleviewer_navposition.'" enableRightClickOpen="'.$wp_simpleviewer_right_click_menu.'" title="'.$wp_simpleviewer_standard_title.'" imagePath="'.$wp_simpleviewer_foldername_regular_composed.'" thumbPath="'.$wp_simpleviewer_foldername_thumbnails_composed.'" wpSimpleviewerWidth="'.$wp_simpleviewer_width.'" wpSimpleviewerHeight="'.$wp_simpleviewer_height.'" wpSimpleviewerBackgroundColor="'.$wp_simpleviewer_bgcolor.'">'."\n";
			
			//start update box for WordPress
			echo '<div id="message" class="updated fade"><p>';
			echo 'Now the XML file will be recreated...'; 
			for ($i = 0; $i < $wp_simpleviewer_number_of_images; $i++) {
				$wp_simpleviewer_xml .= '   <image>'."\n";
				$wp_simpleviewer_xml .= '      <filename>'.attribute_escape( $_POST['wp_simpleviewer_filename_'.$i] ).'</filename>'."\n";
				
				$wp_simpleviewer_completecaption = str_replace("\\\"", "\"", $_POST['wp_simpleviewer_completecaption_'.$i]);
				$wp_simpleviewer_completecaption = str_replace("\'", " ", $wp_simpleviewer_completecaption);
				
				$wp_simpleviewer_newcaption = str_replace("\\\"", ' ', $_POST['wp_simpleviewer_newcaption_'.$i]);
				$wp_simpleviewer_newcaption = str_replace("\'", " ", $wp_simpleviewer_newcaption);
				$wp_simpleviewer_newcaption = attribute_escape( $wp_simpleviewer_newcaption );
				
				$wp_simpleviewer_oldcaption = $_POST['wp_simpleviewer_oldcaption_'.$i];
				
				if ( $wp_simpleviewer_oldcaption != '' ) {
					$wp_simpleviewer_xml .= '      '.str_replace( $wp_simpleviewer_oldcaption, $wp_simpleviewer_newcaption, $wp_simpleviewer_completecaption )."\n";	
				} elseif ( strpos($wp_simpleviewer_completecaption, '[CDATA[]]') ) {
					$wp_simpleviewer_xml .= '      '.str_replace( '[CDATA[]]', '[CDATA['.$wp_simpleviewer_newcaption.']]', $wp_simpleviewer_completecaption )."\n";
				} else {
					$wp_simpleviewer_xml .= '      '.str_replace( '<U></U>', '<U>'.$wp_simpleviewer_newcaption.'</U>', $wp_simpleviewer_completecaption )."\n";
				}
				$wp_simpleviewer_xml .= '   </image>'."\n";
					
			}	//end for i
			$wp_simpleviewer_xml .= '</simpleviewerGallery>';

			if ( !$wp_simpleviewer_xmlfile_handle = @fopen($wp_simpleviewer_xmlfile,"w") ) { 
				echo 'I cannot open XML file: '.$file.' <br />Please check that write permissions of the folder are correct!<br />';
			} elseif ( !fwrite($wp_simpleviewer_xmlfile_handle, $wp_simpleviewer_xml) ) { 
				echo 'I have opened the XML file, but I was not able to write into it: '.$file.'<br />Please check that write permissions of the folder are correct!<br />';   
			} else{
				echo 'Yeah, we are done!'; 
			}
			fclose($wp_simpleviewer_xmlfile_handle);
			chmod($wp_simpleviewer_xmlfile,0777); 		
				
			echo '</p></div>'; //end update box for WordPress (fading div box)
			
		} elseif ( $wp_simpleviewer_option == 'addphotos' ) {	//show xml file's content to edit it
			if ( function_exists('check_admin_referer') ) {
				check_admin_referer($wp_simpleviewer_nonce.'addphotos');
			}
			echo 'This function is not implemented yet!';
		}	//end if option == create ||editxml || addphotos
		
		if ( !isset($wp_simpleviewer_option) || $wp_simpleviewer_option == 'writenewxml' ) {	//show next part only on startpage or after writing new xml file
			?>
			 
			<div class="wrap">
			<h2><?php _e('How to use the WP-SimpleViewer plugin') ?></h2> 
			<?php _e('Upload your photos to a directory placed under /'.$wp_simpleviewer_images_basedir.' using ftp, make the folder writeable for everyone (chmod 777) and then select it from the list below to generate thumbnails and XML file. More information about this is available on the <a href="http://wp-simpleviewer.fuggi82.de" target="_blank">plugin\'s homepage</a>.<br /><br />To show the SimpleViewer gallery on a post or a page just include the foldername in its content like this:<br /><br />Lorem ipsum dolor sit ame: <br />svgallery=your_foldername <br />Consectetuer adipiscing elit.<br /><br />') ?>
			
			<h2><?php _e('Manage WP-SimpleViewer galleries') ?></h2> 
			<?php 
			if ( !is_dir('../'.$wp_simpleviewer_images_basedir) )
				echo '<p>The directory '.$siteurl.'/'.$wp_simpleviewer_images_basedir.' does not exist - please create it and upload your photos to subdirectories of it.</p>';
			else {	// directory exists
					?>
					<form name="form1" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo( attribute_escape($_GET['page']) ); ?>">
					<?php 
					if ( function_exists('wp_nonce_field') ) {
						wp_nonce_field($wp_simpleviewer_nonce.'create');
					}
					?>
					<table class="widefat"> 
						<thead>
						<tr>
							<th scope="col" style="text-align: center"><?php //_e('Select Directory') ?></th>
							<th scope="col"><?php _e('Directory') ?></th>
							<th scope="col"><?php _e('Status') ?></th>
							<th scope="col" style="text-align: center" colspan="1"><?php _e('Action'); ?></th>
						</tr>
						</thead>
						
						<tbody id="the-list">
							<?php
							$directory_id=0;
							$directory_handle = opendir('../'.$wp_simpleviewer_images_basedir);	//todo: review how to change folderdepth
							
							while($file = readdir($directory_handle)) {	
								if ($file[0] != "." && $file[0] != ".." && !strpos($file,".") && strcmp($file, "themes") && strcmp($file, "plugins") && is_dir('../'.$wp_simpleviewer_images_basedir.$file.'/') ) {
									$directory_array[$file] = $file;
								}		
							}	//end while readdir(...)
							if ( !isset($directory_array) ) {
								echo 'There are no directories I can use as a gallery. Please create some!';
							} else {
								sort($directory_array);					
								foreach($directory_array as $directory_name) {
									if ( $directory_id%2 ) {
										echo '<tr id="directory-'.$directory_id.'" class="alternate" >';
									} else {
										echo '<tr id="directory-'.$directory_id.'" >';
									}
									$directory_id++;
									
									if ( is_writable('../'.$wp_simpleviewer_images_basedir.$directory_name.'/') AND (!is_file('../'.$wp_simpleviewer_images_basedir.$directory_name.'/gallery.xml')) OR (current_user_can('edit_others_posts'))   )
										echo '<td> <input type="radio" name="wp_simpleviewer_foldername" id="directory_radio_'.$directory_name.'" value="'.$directory_name.'" /> </td>';
									else {	//directory not writable
										echo '<td> </td>';
									}
									
									echo '<td>'.$directory_name.'</td>';
									
									$plugin_file = attribute_escape($_GET['page']); 
									$editxml_url = 'edit.php?page='.$plugin_file.'&wp_simpleviewer_foldername='.$directory_name.'&option=editxml';
									$addphotos_url = 'edit.php?page='.$plugin_file.'&wp_simpleviewer_foldername='.$directory_name.'&option=addphotos';
									
									if ( function_exists('wp_nonce_url') ){
										$editxml_url = wp_nonce_url($editxml_url, $wp_simpleviewer_nonce.'editxml');
										$addphotos_url = wp_nonce_url($addphotos_url, $wp_simpleviewer_nonce.'addphotos');
									}
									
									if ( !is_writable('../'.$wp_simpleviewer_images_basedir.$directory_name.'/') ) {	//Directory not writable
										echo '<td> This directory is not writable. You have to make it writable (chmod 777) if you want to use them for a gallery. </td>';
										echo '<td>&nbsp;</td>';
									} elseif ( is_file('../'.$wp_simpleviewer_images_basedir.$directory_name.'/gallery.xml') && is_writable('../'.$wp_simpleviewer_images_basedir.$directory_name.'/gallery.xml') ) { //directory is writable and xmlfile exists
										if ( current_user_can('edit_others_posts') ) {
											echo '<td> XML file found, you can recreate or edit the gallery if you like</td>';
											echo '<td><a href="'.$editxml_url.'">Edit captions &amp; settings</a></td>';
										} else {
											echo '<td> XML file found but you do not have the permission to recreate or edit existing galleries</td>';
											echo '<td>&nbsp;</td>';
										}
									} elseif ( is_file('../'.$wp_simpleviewer_images_basedir.$directory_name.'/gallery.xml') && !is_writable('../'.$wp_simpleviewer_images_basedir.$directory_name.'/gallery.xml') ) { //xmlfile exists but not writable
										echo '<td> XML file found, however it is not writable. You have to make it writable (chmod 777) if you want to recreate or edit the gallery</td>';
										echo '<td>&nbsp;</td>';
									} else {	//directory is writable and no xmlfile exists
										echo '<td> You can create gallery files for this folder if you like</td>';
										echo '<td>&nbsp;</td>';
									}
									//echo '<td><a href="'.$addphotos_url.'">Add photos</a></td>';
									echo '</tr>';
								} //end foreach directory_array
							} //end else
							?>
						</tbody>
					</table>
					<p class="submit">
						<input type="hidden" name="option" value="create" />
						<input type="submit" name="Submit" value="<?php _e('Create gallery files for this folder') ?> &raquo;" />
					</p>
					<fieldset class="options">
					<legend><?php _e('Size and colors'); ?></legend>
					<table width="100%" cellspacing="2" cellpadding="5" class="optiontable editform"> 
						<tr valign="top"> 
							<th width="33%" scope="row"><?php _e('Width:'); ?></th> 
							<td><input name="wp_simpleviewer_width" type="text" id="wp_simpleviewer_width" value="<?php echo $wp_simpleviewer_width; ?>" size="10" /><br />
								<?php _e('Default width of the SimpleViewer gallery as it should be shown on the page, e.g. 500 for 500 pixels or 90%.') ?></td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Height:'); ?></th> 
							<td><input name="wp_simpleviewer_height" type="text" id="wp_simpleviewer_height" value="<?php echo $wp_simpleviewer_height; ?>" size="10" /><br />
								<?php _e('Default height of the SimpleViewer gallery as it should be shown on the page, e.g. 500 for 500 pixels or 90%.') ?></td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Textcolor:'); ?></th> 
							<td>#<input name="wp_simpleviewer_textcolor" type="text" id="wp_simpleviewer_textcolor" value="<?php echo $wp_simpleviewer_textcolor; ?>" size="10" /></td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Framecolor:'); ?></th> 
							<td>#<input name="wp_simpleviewer_framecolor" type="text" id="wp_simpleviewer_framecolor" value="<?php echo $wp_simpleviewer_framecolor; ?>" size="10" /></td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Backgroundcolor:'); ?></th> 
							<td>#<input name="wp_simpleviewer_bgcolor" type="text" id="wp_simpleviewer_bgcolor" value="<?php echo $wp_simpleviewer_bgcolor; ?>" size="10" /></td>
						</tr> 
					</table> 
					</fieldset>
					
					<fieldset class="options">
					<legend><?php _e('Gallery creation and appearance'); ?></legend>
					<table width="100%" cellspacing="2" cellpadding="5" class="optiontable editform"> 
						<tr valign="top"> 
							<th width="33%" scope="row"><?php _e('Framewidth:'); ?></th> 
							<td><input name="wp_simpleviewer_framewidth" type="text" id="wp_simpleviewer_framewidth" value="<?php echo $wp_simpleviewer_framewidth; ?>" size="10" /> pixels</td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Stagepadding:'); ?></th> 
							<td><input name="wp_simpleviewer_stagepadding" type="text" id="wp_simpleviewer_stagepadding" value="<?php echo $wp_simpleviewer_stagepadding; ?>" size="10" /> pixels</td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Number of thumbnails in one row:'); ?></th> 
							<td><input name="wp_simpleviewer_thumbnailcolumns" type="text" id="wp_simpleviewer_thumbnailcolumns" value="<?php echo $wp_simpleviewer_thumbnailcolumns; ?>" size="10" /></td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Number of thumbnail rows:'); ?></th> 
							<td><input name="wp_simpleviewer_thumbnailrows" type="text" id="wp_simpleviewer_thumbnailrows" value="<?php echo $wp_simpleviewer_thumbnailrows; ?>" size="10" /></td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Position of navigation:'); ?></th> 
							<td><select name="wp_simpleviewer_navposition" id="wp_simpleviewer_navposition" size="1">
							<option <?php if ($wp_simpleviewer_navposition=="top") echo 'selected="selected"'; ?>>top</option>
							<option <?php if ($wp_simpleviewer_navposition=="bottom") echo 'selected="selected"'; ?>>bottom</option>
							<option <?php if ($wp_simpleviewer_navposition=="left") echo 'selected="selected"'; ?>>left</option>
							<option <?php if ($wp_simpleviewer_navposition=="right") echo 'selected="selected"'; ?>>right</option>
							</select> </td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Enable right click open:'); ?></th> 
							<td><select name="wp_simpleviewer_right_click_menu" id="wp_simpleviewer_right_click_menu" size="1">
							<option <?php if ($wp_simpleviewer_right_click_menu =="true") echo 'selected="selected"'; ?>>true</option>
							<option <?php if ($wp_simpleviewer_right_click_menu =="false") echo 'selected="selected"'; ?>>false</option>
							</select> </td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Max. image dimension:'); ?></th> 
							<td><input name="wp_simpleviewer_max_image_size" type="text" id="wp_simpleviewer_max_image_size" value="<?php echo $wp_simpleviewer_max_image_size; ?>" size="4" /> pixels</td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Image resize quality:'); ?></th> 
							<td><input name="wp_simpleviewer_resizequality" type="text" id="wp_simpleviewer_resizequality" value="<?php echo $wp_simpleviewer_resizequality; ?>" size="4" /> %</td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Show download link or caption:'); ?></th> 
							<td><select name="wp_simpleviewer_show_download_link" id="wp_simpleviewer_show_download_link" size="1">
							<option <?php if ($wp_simpleviewer_show_download_link=="true") echo 'selected="selected"'; ?>>true</option>
							<option <?php if ($wp_simpleviewer_show_download_link=="captions only") echo 'selected="selected"'; ?>>captions only</option>
							<option <?php if ($wp_simpleviewer_show_download_link=="false") echo 'selected="selected"'; ?>>false</option>
							</select> </td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Download link text/caption:'); ?></th> 
							<td><input name="wp_simpleviewer_default_download_link_text" type="text" id="wp_simpleviewer_default_download_link_text" value="<?php echo $wp_simpleviewer_default_download_link_text; ?>" size="40" /> </td>
						</tr> 
						<tr valign="top">
							<th width="33%" scope="row"><?php _e('Gallery title:'); ?></th> 
							<td><?php _e('If the gallery should have a title write it down here, otherwise just leave it empty.') ?><br />
							<input name="wp_simpleviewer_standard_title" type="text" id="wp_simpleviewer_standard_title" value="<?php echo $wp_simpleviewer_standard_title; ?>" size="40" /></td>
						</tr> 
					</table> 
					</fieldset>
		
					<p class="submit">
						<input type="hidden" name="option" value="create" />
						<input type="submit" name="Submit" value="<?php _e('Create gallery files for this folder') ?> &raquo;" />
					</p>
				</form>
			<?php
			}	//end directory exists
		}	//end if plugin is not installed
		?>
		</div> 
		<?php
	}	//end if !isset option ...
}

function wp_simpleviewer_options_page() {
	//this variable is used to check, which version of the plugin is installed in the DB
	//it will be used if DB changes are required for a future version of the plugin
	$wp_simpleviewer_version='1.0';
	$wp_simpleviewer_nonce='wp-simpleviewer-option_';
	
	//these variables are (not yet?) changeable over the wp-admin
	//get WordPress URLs
	$siteurl = get_option("siteurl");
	
	if (isset($_POST['option']) ) {
		$wp_simpleviewer_option = attribute_escape($_POST['option']);
	}
		
	if ($wp_simpleviewer_option == 'reset') {	//plugin should be reset
		if ( function_exists('check_admin_referer') ) {
			check_admin_referer($wp_simpleviewer_nonce.'reset');
		}
		//so we delete all options from the DB:
		delete_option("wp_simpleviewer_width");
		delete_option("wp_simpleviewer_height");
		delete_option("wp_simpleviewer_textcolor");
		delete_option("wp_simpleviewer_framecolor");
		delete_option("wp_simpleviewer_bgcolor");
		delete_option("wp_simpleviewer_framewidth");
		delete_option("wp_simpleviewer_stagepadding");
		delete_option("wp_simpleviewer_thumbnailcolumns");
		delete_option("wp_simpleviewer_thumbnailrows");
		delete_option("wp_simpleviewer_navposition");
		delete_option("wp_simpleviewer_right_click_menu");
		delete_option("wp_simpleviewer_standard_title");
		delete_option("wp_simpleviewer_plugin_basedir");
		delete_option("wp_simpleviewer_images_basedir");
		delete_option("wp_simpleviewer_folder_regular");
		delete_option("wp_simpleviewer_folder_thumbnails");
		delete_option("wp_simpleviewer_max_image_size");
		delete_option("wp_simpleviewer_resizequality");
		delete_option("wp_simpleviewer_show_download_link");
		delete_option("wp_simpleviewer_default_download_link_text");
		delete_option("wp_simpleviewer_version_installed");
		?>
		<div id="message" class="updated fade"><p><strong><?php _e('Plugin has been reset!') ?></strong></p></div>
		
		<div class="wrap">
			<h2><?php _e('Now you can...') ?></h2> 
			
				<?php 
				$plugin_file = attribute_escape($_GET['page']); 
				$deactivate_url = "plugins.php?action=deactivate&amp;plugin=".$plugin_file;

				if ( function_exists('wp_nonce_url') ){
					$deactivate_url = wp_nonce_url("$deactivate_url", 'deactivate-plugin_' . $plugin_file);
				}
				
				_e('<a href="'.$deactivate_url.'">...deactivate the plugin</a> or <a href="options-general.php?page='.$plugin_file.'">start from scratch.</a><br /><br />'); ?>
		</div>
		<?php
	} elseif (!get_option('wp_simpleviewer_version_installed')) {	//The plugin has not been installed yet, default parameters will be added to the DB
		
		$wp_simpleviewer_width = "100%";
		add_option("wp_simpleviewer_width", $wp_simpleviewer_width, "Width of simpleviewer gallery", no);
		
		$wp_simpleviewer_height = "650";
		add_option("wp_simpleviewer_height", $wp_simpleviewer_height, "Height of simpleviewer gallery", no);
		
		$wp_simpleviewer_textcolor = "F8F8F8";
		add_option("wp_simpleviewer_textcolor", $wp_simpleviewer_textcolor, "Textcolor of simpleviewer gallery", no);
		
		$wp_simpleviewer_framecolor = "F8F8F8";
		add_option("wp_simpleviewer_framecolor", $wp_simpleviewer_framecolor, "Framecolor of simpleviewer gallery", no);
		
		$wp_simpleviewer_bgcolor = "343434";
		add_option("wp_simpleviewer_bgcolor", $wp_simpleviewer_bgcolor, "Backgroundcolor of simpleviewer gallery", no);
		
		$wp_simpleviewer_framewidth = "15";
		add_option("wp_simpleviewer_framewidth", $wp_simpleviewer_framewidth, "Framewidth of simpleviewer gallery", no);
		
		$wp_simpleviewer_stagepadding = "20";
		add_option("wp_simpleviewer_stagepadding", $wp_simpleviewer_stagepadding, "Stagepadding of simpleviewer gallery", no);
		
		$wp_simpleviewer_thumbnailcolumns = "4";
		add_option("wp_simpleviewer_thumbnailcolumns", $wp_simpleviewer_thumbnailcolumns, "Thumbnailcolumns of simpleviewer gallery", no);
		
		$wp_simpleviewer_thumbnailrows = "2";
		add_option("wp_simpleviewer_thumbnailrows", $wp_simpleviewer_thumbnailrows, "Thumbnailrows of simpleviewer gallery", no);
		
		$wp_simpleviewer_navposition = "bottom"; 
		add_option("wp_simpleviewer_navposition", $wp_simpleviewer_navposition, "Position of navigation of simpleviewer gallery", no);
		
		$wp_simpleviewer_right_click_menu = "true";
		add_option("wp_simpleviewer_right_click_menu", $wp_simpleviewer_right_click_menu, "Enable right click open for simpleviewer gallery", no);
		
		$wp_simpleviewer_standard_title ="";
		add_option("wp_simpleviewer_standard_title", $wp_simpleviewer_standard_title, "Title of simpleviewer gallery", no);
		
		$wp_simpleviewer_plugin_basedir = "wp-simpleviewer/";
		add_option("wp_simpleviewer_plugin_basedir", $wp_simpleviewer_plugin_basedir, "Base directory of simpleviewer gallery", no);
		
		$wp_simpleviewer_images_basedir = "wp-content/photos/";
		add_option("wp_simpleviewer_images_basedir", $wp_simpleviewer_images_basedir, "Base directory of images for simpleviewer gallery", no);
		
		$wp_simpleviewer_folder_regular = "reg";
		add_option("wp_simpleviewer_folder_regular", $wp_simpleviewer_folder_regular, "Prefix for regular pictures for simpleviewer gallery", no);
		
		$wp_simpleviewer_folder_thumbnails = "tn";
		add_option("wp_simpleviewer_folder_thumbnails", $wp_simpleviewer_folder_thumbnails, "Prefix for thumbnails for simpleviewer gallery", no);
		
		$wp_simpleviewer_max_image_size = "300";
		add_option("wp_simpleviewer_max_image_size", $wp_simpleviewer_max_image_size, "Maximum image dimension for simpleviewer gallery", no);
		
		$wp_simpleviewer_resizequality = "85";
		add_option("wp_simpleviewer_resizequality", $wp_simpleviewer_resizequality, "Image quality when resizing images for simpleviewer gallery", no);
		
		$wp_simpleviewer_show_download_link = "true";
		add_option("wp_simpleviewer_show_download_link", $wp_simpleviewer_show_download_link, "Show download links in simpleviewer gallery", no);
		
		$wp_simpleviewer_default_download_link_text = "Show photo in full size";
		add_option("wp_simpleviewer_default_download_link_text", $wp_simpleviewer_default_download_link_text, "Default download link text for simpleviewer gallery", no);
		
		//Finally add the version parameter - No need to edit this parameter in the GUI
		add_option("wp_simpleviewer_version_installed", $wp_simpleviewer_version, "Is the WP-SimpleViewer plugin already installed?", no);
		?>
		<div id="message" class="updated fade"><p><strong><?php _e('Plugin has been configured!') ?></strong></p></div>
		<?php
		
	} elseif ($wp_simpleviewer_option == 'update') {	// Check if form data has been sent to update options
		if ( function_exists('check_admin_referer') ) {
			check_admin_referer($wp_simpleviewer_nonce.'update');
		}
	
		if ( isset($_POST['wp_simpleviewer_width']) ) {
			$wp_simpleviewer_width = attribute_escape($_POST['wp_simpleviewer_width']);
			update_option('wp_simpleviewer_width', $wp_simpleviewer_width, '','');
		}
		if ( isset($_POST['wp_simpleviewer_height']) ) {
			$wp_simpleviewer_height = attribute_escape($_POST['wp_simpleviewer_height']);
			update_option('wp_simpleviewer_height', $wp_simpleviewer_height, '','');
		}
		if ( isset($_POST['wp_simpleviewer_textcolor']) ) {
			$wp_simpleviewer_textcolor = attribute_escape($_POST['wp_simpleviewer_textcolor']);
			update_option('wp_simpleviewer_textcolor', $wp_simpleviewer_textcolor, '','');
		}
		if ( isset($_POST['wp_simpleviewer_framecolor']) ) {
			$wp_simpleviewer_framecolor = attribute_escape($_POST['wp_simpleviewer_framecolor']);
			update_option('wp_simpleviewer_framecolor', $wp_simpleviewer_framecolor, '','');
		}
		if ( isset($_POST['wp_simpleviewer_bgcolor']) ) {
			$wp_simpleviewer_bgcolor = attribute_escape($_POST['wp_simpleviewer_bgcolor']);
			update_option('wp_simpleviewer_bgcolor', $wp_simpleviewer_bgcolor, '','');
		}
		if ( isset($_POST['wp_simpleviewer_framewidth']) ) {
			$wp_simpleviewer_framewidth = attribute_escape($_POST['wp_simpleviewer_framewidth']);
			update_option('wp_simpleviewer_framewidth', $wp_simpleviewer_framewidth, '','');
		}
		if ( isset($_POST['wp_simpleviewer_stagepadding']) ) {
			$wp_simpleviewer_stagepadding = attribute_escape($_POST['wp_simpleviewer_stagepadding']);
			update_option('wp_simpleviewer_stagepadding', $wp_simpleviewer_stagepadding, '','');
		}
		if ( isset($_POST['wp_simpleviewer_thumbnailcolumns']) ) {
			$wp_simpleviewer_thumbnailcolumns = attribute_escape($_POST['wp_simpleviewer_thumbnailcolumns']);
			update_option('wp_simpleviewer_thumbnailcolumns', $wp_simpleviewer_thumbnailcolumns, '','');
		}
		if ( isset($_POST['wp_simpleviewer_thumbnailrows']) ) {
			$wp_simpleviewer_thumbnailrows = attribute_escape($_POST['wp_simpleviewer_thumbnailrows']);
			update_option('wp_simpleviewer_thumbnailrows', $wp_simpleviewer_thumbnailrows, '','');
		}
		if ( isset($_POST['wp_simpleviewer_navposition']) ) {
			$wp_simpleviewer_navposition = attribute_escape($_POST['wp_simpleviewer_navposition']);
			update_option('wp_simpleviewer_navposition', $wp_simpleviewer_navposition, '','');
		}
		if ( isset($_POST['wp_simpleviewer_right_click_menu']) ) {
			$wp_simpleviewer_right_click_menu = attribute_escape($_POST['wp_simpleviewer_right_click_menu']);
			update_option('wp_simpleviewer_right_click_menu', $wp_simpleviewer_right_click_menu, '','');
		}
		if ( isset($_POST['wp_simpleviewer_plugin_basedir']) ) {
			$wp_simpleviewer_plugin_basedir = attribute_escape($_POST['wp_simpleviewer_plugin_basedir']);
			$wp_simpleviewer_plugin_basedir = verify_directory_name($wp_simpleviewer_plugin_basedir);
			update_option('wp_simpleviewer_plugin_basedir', $wp_simpleviewer_plugin_basedir, '','');
		}
		if ( isset($_POST['wp_simpleviewer_images_basedir']) ) {
			$wp_simpleviewer_images_basedir = attribute_escape($_POST['wp_simpleviewer_images_basedir']);
			$wp_simpleviewer_images_basedir = verify_directory_name($wp_simpleviewer_images_basedir);
			update_option('wp_simpleviewer_images_basedir', $wp_simpleviewer_images_basedir, '','');
		}
		if ( isset($_POST['wp_simpleviewer_folder_regular']) ) {
			$wp_simpleviewer_folder_regular = attribute_escape($_POST['wp_simpleviewer_folder_regular']);
			update_option('wp_simpleviewer_folder_regular', $wp_simpleviewer_folder_regular, '','');
		}
		if ( isset($_POST['wp_simpleviewer_folder_thumbnails']) ) {
			$wp_simpleviewer_folder_thumbnails = attribute_escape($_POST['wp_simpleviewer_folder_thumbnails']);
			update_option('wp_simpleviewer_folder_thumbnails', $wp_simpleviewer_folder_thumbnails, '','');
		}
		if ( isset($_POST['wp_simpleviewer_max_image_size']) ) {
			$wp_simpleviewer_max_image_size = attribute_escape($_POST['wp_simpleviewer_max_image_size']);
			update_option('wp_simpleviewer_max_image_size', $wp_simpleviewer_max_image_size, '','');
		}
		if ( isset($_POST['wp_simpleviewer_resizequality']) ) {
			$wp_simpleviewer_resizequality = attribute_escape($_POST['wp_simpleviewer_resizequality']);
			update_option('wp_simpleviewer_resizequality', $wp_simpleviewer_resizequality, '','');
		}
		if ( isset($_POST['wp_simpleviewer_show_download_link']) ) {
			$wp_simpleviewer_show_download_link = attribute_escape($_POST['wp_simpleviewer_show_download_link']);
			update_option('wp_simpleviewer_show_download_link', $wp_simpleviewer_show_download_link, '','');
		}
		if ( isset($_POST['wp_simpleviewer_default_download_link_text']) ) {
			$wp_simpleviewer_default_download_link_text = str_replace("\\\"", ' ', $_POST['wp_simpleviewer_default_download_link_text']);
			$wp_simpleviewer_default_download_link_text = str_replace("\'", " ", $wp_simpleviewer_default_download_link_text);
			$wp_simpleviewer_default_download_link_text = attribute_escape( $wp_simpleviewer_default_download_link_text );
			update_option('wp_simpleviewer_default_download_link_text', $wp_simpleviewer_default_download_link_text, '','');
		}
		if ( isset($_POST['wp_simpleviewer_standard_title']) ) {
			$wp_simpleviewer_standard_title = str_replace("\\\"", ' ', $_POST['wp_simpleviewer_standard_title']);
			$wp_simpleviewer_standard_title = str_replace("\'", " ", $wp_simpleviewer_standard_title);
			$wp_simpleviewer_standard_title = attribute_escape( $wp_simpleviewer_standard_title );
			update_option('wp_simpleviewer_standard_title', $wp_simpleviewer_standard_title, '','');
		}
		?>
		<div id="message" class="updated fade"><p><strong><?php _e('Options saved.') ?></strong></p></div>
		<?php
		
		
	} else {	//no variables sent & plugin is installed and should not be reset, so let's get them from DB
		$wp_simpleviewer_version_installed = get_option('wp_simpleviewer_version_installed');
		
		if ( $wp_simpleviewer_version_installed != $wp_simpleviewer_version ) {	//check if update of DB is needed
			update_wp_simpleviewer( $wp_simpleviewer_version_installed); 
			update_option('wp_simpleviewer_version_installed', $wp_simpleviewer_version, '','');
		} 
		$wp_simpleviewer_width = get_option("wp_simpleviewer_width");
		$wp_simpleviewer_height = get_option("wp_simpleviewer_height");
		$wp_simpleviewer_textcolor = get_option("wp_simpleviewer_textcolor");
		$wp_simpleviewer_framecolor = get_option("wp_simpleviewer_framecolor");
		$wp_simpleviewer_bgcolor = get_option("wp_simpleviewer_bgcolor");
		$wp_simpleviewer_framewidth = get_option("wp_simpleviewer_framewidth");
		$wp_simpleviewer_stagepadding = get_option("wp_simpleviewer_stagepadding");
		$wp_simpleviewer_thumbnailcolumns = get_option("wp_simpleviewer_thumbnailcolumns");
		$wp_simpleviewer_thumbnailrows = get_option("wp_simpleviewer_thumbnailrows");
		$wp_simpleviewer_navposition = get_option("wp_simpleviewer_navposition");
		$wp_simpleviewer_right_click_menu = get_option("wp_simpleviewer_right_click_menu");
		$wp_simpleviewer_standard_title = get_option("wp_simpleviewer_standard_title");
		$wp_simpleviewer_plugin_basedir = get_option("wp_simpleviewer_plugin_basedir");
		$wp_simpleviewer_images_basedir = get_option("wp_simpleviewer_images_basedir");
		$wp_simpleviewer_folder_regular = get_option("wp_simpleviewer_folder_regular");
		$wp_simpleviewer_folder_thumbnails = get_option("wp_simpleviewer_folder_thumbnails");
		$wp_simpleviewer_max_image_size = get_option("wp_simpleviewer_max_image_size");
		$wp_simpleviewer_resizequality = get_option("wp_simpleviewer_resizequality");
		$wp_simpleviewer_show_download_link = get_option("wp_simpleviewer_show_download_link");
		$wp_simpleviewer_default_download_link_text = get_option("wp_simpleviewer_default_download_link_text");
		
	}	// end if updated == true	
	
	
	if ( $wp_simpleviewer_option != 'reset' || !isset($wp_simpleviewer_option) )	//show the main page only if plugin should not be reset
	{
		?>	
		<div class="wrap"> 
			<h2><?php _e('WP-SimpleViewer options') ?></h2> 
			<form name="form2" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo( attribute_escape($_GET['page']) ); ?>">
			<?php 
			if ( function_exists('wp_nonce_field') ) {
				wp_nonce_field($wp_simpleviewer_nonce.'update');
			}
			?>
			<fieldset class="options">
			<legend><?php _e('Size and colors'); ?></legend>
			<table width="100%" cellspacing="2" cellpadding="5" class="optiontable editform"> 
				<tr valign="top"> 
					<th width="33%" scope="row"><?php _e('Width:'); ?></th> 
					<td><input name="wp_simpleviewer_width" type="text" id="wp_simpleviewer_width" value="<?php echo $wp_simpleviewer_width; ?>" size="10" /><br />
						<?php _e('Default width of the SimpleViewer gallery as it should be shown on the page, e.g. 500 for 500 pixels or 90%.') ?></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Height:'); ?></th> 
					<td><input name="wp_simpleviewer_height" type="text" id="wp_simpleviewer_height" value="<?php echo $wp_simpleviewer_height; ?>" size="10" /><br />
						<?php _e('Default height of the SimpleViewer gallery as it should be shown on the page, e.g. 500 for 500 pixels or 90%.') ?></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Textcolor:'); ?></th> 
					<td>#<input name="wp_simpleviewer_textcolor" type="text" id="wp_simpleviewer_textcolor" value="<?php echo $wp_simpleviewer_textcolor; ?>" size="10" /></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Framecolor:'); ?></th> 
					<td>#<input name="wp_simpleviewer_framecolor" type="text" id="wp_simpleviewer_framecolor" value="<?php echo $wp_simpleviewer_framecolor; ?>" size="10" /></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Backgroundcolor:'); ?></th> 
					<td>#<input name="wp_simpleviewer_bgcolor" type="text" id="wp_simpleviewer_bgcolor" value="<?php echo $wp_simpleviewer_bgcolor; ?>" size="10" /></td>
				</tr> 
			</table> 
			</fieldset>
			
			<fieldset class="options">
			<legend><?php _e('Gallery creation and appearance'); ?></legend>
			<table width="100%" cellspacing="2" cellpadding="5" class="optiontable editform"> 
				<tr valign="top"> 
					<th width="33%" scope="row"><?php _e('Framewidth:'); ?></th> 
					<td><input name="wp_simpleviewer_framewidth" type="text" id="wp_simpleviewer_framewidth" value="<?php echo $wp_simpleviewer_framewidth; ?>" size="10" /> pixels</td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Stagepadding:'); ?></th> 
					<td><input name="wp_simpleviewer_stagepadding" type="text" id="wp_simpleviewer_stagepadding" value="<?php echo $wp_simpleviewer_stagepadding; ?>" size="10" /> pixels</td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Number of thumbnails in one row:'); ?></th> 
					<td><input name="wp_simpleviewer_thumbnailcolumns" type="text" id="wp_simpleviewer_thumbnailcolumns" value="<?php echo $wp_simpleviewer_thumbnailcolumns; ?>" size="10" /></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Number of thumbnail rows:'); ?></th> 
					<td><input name="wp_simpleviewer_thumbnailrows" type="text" id="wp_simpleviewer_thumbnailrows" value="<?php echo $wp_simpleviewer_thumbnailrows; ?>" size="10" /></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Position of navigation:'); ?></th> 
					<td><select name="wp_simpleviewer_navposition" id="wp_simpleviewer_navposition" size="1">
				    <option <?php if ($wp_simpleviewer_navposition=="top") echo 'selected="selected"'; ?>>top</option>
					<option <?php if ($wp_simpleviewer_navposition=="bottom") echo 'selected="selected"'; ?>>bottom</option>
					<option <?php if ($wp_simpleviewer_navposition=="left") echo 'selected="selected"'; ?>>left</option>
					<option <?php if ($wp_simpleviewer_navposition=="right") echo 'selected="selected"'; ?>>right</option>
			    	</select> </td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Enable right click open:'); ?></th> 
					<td><select name="wp_simpleviewer_right_click_menu" id="wp_simpleviewer_right_click_menu" size="1">
				    <option <?php if ($wp_simpleviewer_right_click_menu =="true") echo 'selected="selected"'; ?>>true</option>
					<option <?php if ($wp_simpleviewer_right_click_menu =="false") echo 'selected="selected"'; ?>>false</option>
					</select> </td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Max. image dimension:'); ?></th> 
					<td><input name="wp_simpleviewer_max_image_size" type="text" id="wp_simpleviewer_max_image_size" value="<?php echo $wp_simpleviewer_max_image_size; ?>" size="4" /> pixels</td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Image resize quality:'); ?></th> 
					<td><input name="wp_simpleviewer_resizequality" type="text" id="wp_simpleviewer_resizequality" value="<?php echo $wp_simpleviewer_resizequality; ?>" size="4" /> %</td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Show download link or caption:'); ?></th> 
					<td><select name="wp_simpleviewer_show_download_link" id="wp_simpleviewer_show_download_link" size="1">
				    <option <?php if ($wp_simpleviewer_show_download_link=="true") echo 'selected="selected"'; ?>>true</option>
					<option <?php if ($wp_simpleviewer_show_download_link=="captions only") echo 'selected="selected"'; ?>>captions only</option>
					<option <?php if ($wp_simpleviewer_show_download_link=="false") echo 'selected="selected"'; ?>>false</option>
					</select> </td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Standard download link text/caption:'); ?></th> 
					<td><input name="wp_simpleviewer_default_download_link_text" type="text" id="wp_simpleviewer_default_download_link_text" value="<?php echo $wp_simpleviewer_default_download_link_text; ?>" size="40" /> </td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Standard gallery name:'); ?></th> 
					<td><input name="wp_simpleviewer_standard_title" type="text" id="wp_simpleviewer_standard_title" value="<?php echo $wp_simpleviewer_standard_title; ?>" size="40" /></td>
				</tr> 
			</table> 
			</fieldset>
			
			<fieldset class="options">
			<legend><?php _e('Directory settings'); ?></legend>
			<table width="100%" cellspacing="2" cellpadding="5" class="optiontable editform"> 
				<tr valign="top"> 
					<th width="33%" scope="row"><?php _e('Directory of WP-SimpleViewer plugin:'); ?></th> 
					<td><?php echo $siteurl; ?>/wp-content/plugins/<input name="wp_simpleviewer_plugin_basedir" type="text" id="wp_simpleviewer_plugin_basedir" value="<?php echo $wp_simpleviewer_plugin_basedir; ?>" size="40" /></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Base directory for images:'); ?></th> 
					<td><?php echo $siteurl; ?>/<input name="wp_simpleviewer_images_basedir" type="text" id="wp_simpleviewer_images_basedir" value="<?php echo $wp_simpleviewer_images_basedir; ?>" size="40" /></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Foldername for regular pictures:'); ?></th> 
					<td><input name="wp_simpleviewer_folder_regular" type="text" id="wp_simpleviewer_folder_regular" value="<?php echo $wp_simpleviewer_folder_regular; ?>" size="10" /></td>
				</tr> 
				<tr valign="top">
					<th width="33%" scope="row"><?php _e('Foldername for thumbnails:'); ?></th> 
					<td><input name="wp_simpleviewer_folder_thumbnails" type="text" id="wp_simpleviewer_folder_thumbnails" value="<?php echo $wp_simpleviewer_folder_thumbnails; ?>" size="10" /></td>
				</tr> 
			</table> 
			</fieldset>
			
			<p class="submit">
				<input type="hidden" name="option" value="update" />
				<input type="submit" name="Submit" value="<?php _e('Update options') ?> &raquo;" />
			</p>
			</form> 
		</div>
		
		<div class="wrap"> 
			<h2><?php _e('Reset WP-SimpleViewer plugin') ?></h2> 
			<form name="form3" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo( attribute_escape($_GET['page']) ); ?>">
			<?php _e('Pressing the uninstall button does not delete any files. It just removes all settings from the database and asks you if you want to deactivate the plugin or start from scratch.'); ?>
			<p class="submit">
				<?php 
				if ( function_exists('wp_nonce_field') ) {
					wp_nonce_field($wp_simpleviewer_nonce.'reset'); 
				}
				?>
				<input type="hidden" name="option" value="reset" />
				<input type="submit" name="Submit" value="<?php _e('Reset WP-SimpleViewer plugin') ?> &raquo;" />
			</p>
			</form>
		</div>
	<?php
	}	//end if option != reset
}	//end function wp_simpleviewer_options_page()

//This function verifies that the new directory has a "/" at the end
function verify_directory_name($wp_simpleviewer_plugin_basedir)
{
	$wp_simpleviewer_plugin_basedir = trim($wp_simpleviewer_plugin_basedir);
	if ( $wp_simpleviewer_plugin_basedir[strlen($wp_simpleviewer_plugin_basedir)-1] != '/')
		return $wp_simpleviewer_plugin_basedir.'/';
	else
		return $wp_simpleviewer_plugin_basedir;
}

// Function to delete all old image & xml files if already existing, will not return anything or handle errors (maybe this will follow soon)
function cleanup_old_files($wp_simpleviewer_xmlfile, $wp_simpleviewer_foldername_regular_composed, $wp_simpleviewer_foldername_thumbnails_composed)
{
		//Remove old xmlfile
		if (is_writable($wp_simpleviewer_xmlfile)){
			unlink($wp_simpleviewer_xmlfile);
		}
		
		//Remove old regular images and thumbnails
		if ( is_dir($wp_simpleviewer_foldername_regular_composed) ){
					$directory_handle = opendir($wp_simpleviewer_foldername_regular_composed);
					 while($file = readdir($directory_handle)) {	
						if ($file[0] != "." && $file[0] != ".." ){
							unlink($wp_simpleviewer_foldername_regular_composed.'/'.$file);
						}		
					 }	//end loop thru files
					 rmdir($wp_simpleviewer_foldername_regular_composed);
		}
		
		if ( is_dir($wp_simpleviewer_foldername_thumbnails_composed) ){
					$directory_handle = opendir($wp_simpleviewer_foldername_thumbnails_composed);
					 while($file = readdir($directory_handle)) {	
						if ($file[0] != "." && $file[0] != ".." ){
							unlink($wp_simpleviewer_foldername_thumbnails_composed.'/'.$file);
						}		
					 }	//end loop thru files		
					 rmdir($wp_simpleviewer_foldername_thumbnails_composed);
		}
}	//end function cleanup_old_files()

// Function to create resized images
// To learn more about this function check out this tutorial: http://www.reconn.us/content/view/32/43/
function create_resized_image($src_filepath, $dst_filepath, $new_image_squared, $max_size_dest, $wp_simpleviewer_resizequality)
{
	//get image extension.
	$ext=getExtension($src_filepath);
	//creates the new image using the appropriate function from gd library
	if(!strcmp("jpg",$ext) || !strcmp("jpeg",$ext))
		$src_img = @imagecreatefromjpeg($src_filepath);
	elseif(!strcmp("png",$ext))
		$src_img = @imagecreatefrompng($src_filepath);
	else {
		echo 'Invalid file type "'.$ext.'" for file "'.$src_filepath.'" - skipping thumb creation for this file. <br />';
		return 0;
	}
	
	if (!$src_img) {
		echo 'The image file '.$src_filepath.' does not have a correct image format, skipping thumb creation for this file - please upload it again!<br />';
		return 0;
	} else {
		//gets the dimmensions of the image
		$old_x=imageSX($src_img);
		$old_y=imageSY($src_img);
	
		//set default size values
		$new_x       = $max_size_dest;
		$new_y       = $max_size_dest;
		$distance_x  = 0;
		$distance_y  = 0;
		$px_to_use_x = $old_x;
		$px_to_use_y = $old_y;
		//calculate ratio
		$ratio = $old_x/$old_y;
		
		if ($new_image_squared==true){		//generate squared new image (with cutting - used for thumbs)
			// Check image shape 
			if ($ratio > 1) {			//horizontal
				$distance_x  = ($old_x - $old_y) / 2;
				//$distance_y= 0;
				$px_to_use_x = $old_y;
				$px_to_use_y = $old_y;
	
			} elseif ($ratio < 1) {	//vertical
				//$distance_x= 0;
				$distance_y  = ($old_y - $old_x) / 2;
				$px_to_use_x = $old_x;
				$px_to_use_y = $old_x;
			}
		} else {	//resize original image and keep ratio (used for all other images)
			// Check image shape 
			if ($ratio > 1) {			//horizontal
				$new_y = $max_size_dest/$ratio;
			
			} elseif ($ratio < 1) {	//vertical
				$new_x = $max_size_dest*$ratio;
			} 
		}		//end resize original image
		
		// we create a new image with the new dimmensions
		$dst_img = imagecreatetruecolor($new_x, $new_y);
			
		// resize the big image to the new created one
		// parameter used:
		// $distance_x  - distance from left image corner to start with thumb in x direction (left to right)
		// $distance_y  - distance from left image corner to start with thumb in y direction (up to down)
		// $new_x   - x-size of destination image
		// $new_y   - y-size of destination image
		// $px_to_use_x - how many px of the old image should be used in x direction
		// $px_to_use_y - how many px of the old image should be used in y direction
		imagecopyresized($dst_img, $src_img, 0, 0, $distance_x, $distance_y, $new_x, $new_y, $px_to_use_x, $px_to_use_y);
		
		// output the created image to the file.
		if(!strcmp("png",$ext)) {
			if (!@imagepng($dst_img,$dst_filepath, $wp_simpleviewer_resizequality) ){
				echo 'New image "'.$dst_filepath.'" could not be created - skipping thumb creation for this file. <br />';
				imagedestroy($dst_img); 
				imagedestroy($src_img); 
				return 0;
			}
		} elseif (!@imagejpeg($dst_img,$dst_filepath, $wp_simpleviewer_resizequality) ) {
			echo 'New image "'.$dst_filepath.'" could not be created - skipping thumb creation for this file. <br />';
			imagedestroy($dst_img); 
			imagedestroy($src_img); 
			return 0; 
		} //else do the following...
		
		//destroys source and destination images. 
		imagedestroy($dst_img); 
		imagedestroy($src_img); 
		
		return 1;
	}	//end if !srv_img
} //end function create_resized_image

// This function reads the extension of the file. 
// It is used to determine if the file is an image by checking the extension. 
function getExtension($str) {
	$i = strrpos($str,".");
	if (!$i) { 
		return ""; 
	}
	$l = strlen($str) - $i;
	$ext = substr($str,$i+1,$l);
	return strtolower($ext);
}

function update_wp_simpleviewer($wp_simpleviewer_version_installed) {
	if ( $wp_simpleviewer_version_installed == '0.4' ) {
		delete_option("wp_simpleviewer_align");
		delete_option("wp_simpleviewer_thumbnailsize");
	} else if ( $wp_simpleviewer_version_installed == '0.5' ) {
		delete_option("wp_simpleviewer_thumbnailsize");
	}
	?>
	<div id="message" class="updated fade"><p><strong><?php _e('Database has been updated for the new plugin version!') ?></strong></p></div>
	<?php
}
?>